function AlternativeSkirmish:SceneTest()
--[[ THIS TEST IS DONE AUTOMATICALLY BY THE GAME NOW; IT SCANS THE SCRIPT FOR ANY MENTIONS OF "GetArea" AND TESTS THE SCENES FOR HAVING THOSE USED AREAS DEFINED!
	-- See if the required areas are present in the test scene
	if not (TestScene:HasArea("LZ Team 1") and TestScene:HasArea("LZ Team 2")) then
		-- If the test scene failed the compatibility test, invalidate it
		TestScene = nil;
	end
--]]
end

function AlternativeSkirmish:StartActivity()
	print("START! -- AlternativeSkirmish:StartActivity()!");
	self.playertally = 0;
	self.playerlist = {};
	self.currentenemies = 0;

	self.timeElapsed = 0;
	self.TechElapsed = 0;
	self.StopSending = 5;
	self.Specialtime = 60;
	self.SpecialStage = 0;
	self.SpecialStageRepeat = 0;

	self.wavewaitTimer = Timer();

----------------------------------------

	self.longestWaveDelay = 40000; -- Wave delay on lowest difficulty
	self.shortestWaveDelay = 28500; -- Wave delay on highest difficulty
	self.Diff = 0
	-- All delays in between are calculated with MATH

	self.maxDeliveryLoad = 2; -- Maximum number of units per delivery
	self.minDeliveryLoad = 1; -- Minimum number of units per delivery

	self.chanceOfCrab = 0.05; -- Chance of getting an ACrab. If you don't get a crab, an AHuman is delivered
	self.chanceOfRocket = 0.0; -- Chance of getting a rocket. If you don't get a rocket, a dropship comes

	self.PrimaryWeaponList = {"Sniper Rifle", "Nailer Cannon", "Destroyer Cannon", "Compact Assault Rifle", "Assault Rifle"};
	self.ShortRangePrimaryWeaponList = { "Blaster", "Nailer Cannon", "Destroyer Cannon", "Compact Assault Rifle", "Flamer", "Shotgun", "Rocket Launcher" , "Bazooka" };
	self.AdvancedPrimaryWeaponList = { "Sniper Rifle", "Nailer Cannon", "Assault Rifle", "Heavy Sniper Rifle", "Gatling Gun","Spike Launcher", "Flak Cannon"};
	self.AdvancedShortRangePrimaryWeaponList = { "Grenade Launcher", "Nailer Cannon", "Assault Rifle", "Gatling Gun", "Napalm Flamer", "Spike Launcher", "Auto Shotgun", "Mauler Shotgun"};
	self.SecondaryWeaponList = { "Nailgun", "Rail Pistol", "Pistol", "Auto Pistol", "Heavy Pistol", "Uzi", "Shortgun", "Desert Eagle", "Glock", "Luger" };
	self.DiggerList = { "Light Digger", "Medium Digger", "Heavy Digger", "Pulse Digger", "Turbo Digger" };
	self.BombList = { "Pineapple Grenade", "Grenade", "Cluster Grenade" };
	self.ShieldList = { "Riot Shield" };

	self.SimpleBodyList = { "Mia", "Dafred", "Dimitri", "Gordon", "Brutus", "Sandra"};
	self.BodyList = { "Soldier Heavy", "Soldier Light"};
	self.AdvancedBodyList = { "Soldier Heavy", "Browncoat Light", "Browncoat Heavy" };
	self.CrabList = { "Dreadnought" };

	self.DropShipList = { "Drop Ship", "Drop Ship MK1" };
	self.RocketList = { "Rocket MK1", "Rocket MK2" };
	self.PodList = { "Drop Crate" };

----------------------------------------

    for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
        if self:PlayerActive(player) and self:PlayerHuman(player) then
		self.playerlist[player + 1] = true;
		self.playertally = self.playertally + 1;
		-- Check if we already have a brain assigned
			if not self:GetPlayerBrain(player) then
				local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));
				-- If we can't find an unassigned brain in the scene to give each player, then force to go into editing mode to place one
				if not foundBrain then
					self.ActivityState = Activity.EDITING;
					AudioMan:ClearMusicQueue();
					AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/ccambient4.ogg", -1, -1);
				else
					-- Set the found brain to be the selected actor at start
					self:SetPlayerBrain(foundBrain, player);
					self:SwitchToActor(foundBrain, player, self:GetTeamOfPlayer(player));
					self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
					-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
					self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
				end
			end
		end
	end

	self.ESpawnTimer = Timer();
	--self.LZ = SceneMan.Scene:GetArea("LZ Team 1");
	--self.EnemyLZ = SceneMan.Scene:GetArea("LZ Team 2");
	
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self:SetTeamFunds(7500, Activity.TEAM_1);
		self:SetTeamFunds(7500, Activity.TEAM_2);
		self:SetTeamFunds(7500, Activity.TEAM_3);
		self:SetTeamFunds(7500, Activity.TEAM_4);
		self.wavewaittime = self.longestWaveDelay;
		self.Diff = 0.5
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self:SetTeamFunds(6000, Activity.TEAM_1);
		self:SetTeamFunds(6000, Activity.TEAM_2);
		self:SetTeamFunds(6000, Activity.TEAM_3);
		self:SetTeamFunds(6000, Activity.TEAM_4);
		self.wavewaittime = ((4/5)*(self.longestWaveDelay - self.shortestWaveDelay)) + self.shortestWaveDelay;
		self.Diff = 0.7
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self:SetTeamFunds(4500, Activity.TEAM_1);
		self:SetTeamFunds(4500, Activity.TEAM_2);
		self:SetTeamFunds(4500, Activity.TEAM_3);
		self:SetTeamFunds(4500, Activity.TEAM_4);
		self.wavewaittime = ((3/5)*(self.longestWaveDelay - self.shortestWaveDelay)) + self.shortestWaveDelay;
		self.Diff = 1
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self:SetTeamFunds(3000, Activity.TEAM_1);
		self:SetTeamFunds(3000, Activity.TEAM_2);
		self:SetTeamFunds(3000, Activity.TEAM_3);
		self:SetTeamFunds(3000, Activity.TEAM_4);
		self.wavewaittime = ((2/5)*(self.longestWaveDelay - self.shortestWaveDelay)) + self.shortestWaveDelay;
		self.Diff = 1.8
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self:SetTeamFunds(2000, Activity.TEAM_1);
		self:SetTeamFunds(2000, Activity.TEAM_2);
		self:SetTeamFunds(2000, Activity.TEAM_3);
		self:SetTeamFunds(2000, Activity.TEAM_4);
		self.wavewaittime = ((1/5)*(self.longestWaveDelay - self.shortestWaveDelay)) + self.shortestWaveDelay;
		self.Diff = 2.8
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self:SetTeamFunds(1500, Activity.TEAM_1);
		self:SetTeamFunds(1500, Activity.TEAM_2);
		self:SetTeamFunds(1500, Activity.TEAM_3);
		self:SetTeamFunds(1500, Activity.TEAM_4);
		self.wavewaittime = self.shortestWaveDelay;
		self.Diff = 5
	end

	print(self.wavewaittime);

	self.StartTimer = Timer();
	
  self.PlayerBrainPos = {};
--  local i = 0
--  while i < 5 do
--    self.PlayerBrainPos[i] = self:GetPlayerBrain(i).Pos.X;
--  end
end

function AlternativeSkirmish:PauseActivity(pause)
    	print("PAUSE! -- AlternativeSkirmish:PauseActivity()!");
end

function AlternativeSkirmish:EndActivity()
    	print("END! -- AlternativeSkirmish:EndActivity()!");
		
end

function AlternativeSkirmish:UpdateActivity()
  
  self.wavewaittime = 12000/self.Diff + ((self.wavewaittime - 12000/self.Diff) * 0.99994)

  --Used for locating average point of brains for AI purposes
  local braincount = 0;
  local brainPositionX={};
  local brainPositionX2=0;
  
  local EnemySpawnX1 = 0;
  local EnemySpawnX2 = 0;
  local PlayerSpawnX1 = {};
  local PlayerSpawnX2 = {};
    
	if self.ActivityState ~= Activity.OVER and self.ActivityState ~= Activity.EDITING then
    --Time Elapsed
    self.timeElapsed = self.timeElapsed + 0.01
    self.TechElapsed = self.TechElapsed + 0.0025 + (self.timeElapsed * 0.00010 * self.Diff)
    self.StopSending = self.StopSending - 0.01
		if startedMusic == nil then
			startedMusic = true;
			AudioMan:ClearMusicQueue();
			AudioMan:PlayMusic("Base.rte/Music/Watts/Last Man.ogg", -1, -1);
		end
    
		-- Clear all objective markers, they get re-added each frame
		self:ClearObjectivePoints();

		for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
			if self:PlayerActive(player) and self:PlayerHuman(player) then
				if not self.StartTimer:IsPastSimMS(3000) then
					FrameMan:SetScreenText("Survive against the enemy attacks!", player, 333, 5000, true);
				end
        if self.timeElapsed >= self.Specialtime - 2.5 then
          if self.SpecialStage == 0 then
            FrameMan:SetScreenText("Browncoats incoming!!!", player, 333, 5000, true);
          end
          if self.SpecialStage == 4 then
            FrameMan:SetScreenText("Dreadnaughts incoming!!!", player, 333, 5000, true);
          end
          if self.SpecialStage == 7  then
            FrameMan:SetScreenText("Coalition assault troops incoming!!!", player, 333, 5000, true);
          end
        end
				local team = self:GetTeamOfPlayer(player);
				-- Check if any player's brain is dead
				if not MovableMan:IsActor(self:GetPlayerBrain(player)) then
					self:SetPlayerBrain(nil, player);
					self:ResetMessageTimer(player);
					FrameMan:ClearScreenText(player);
					FrameMan:SetScreenText("Your brain has been destroyed!", player, 333, -1, false);
					if self.playerlist[player + 1] == true then
						self.playerlist[player + 1] = false;
						self.playertally = self.playertally - 1;
					end
				else
          braincount = braincount + 1;
          brainPositionX[braincount] = self:GetPlayerBrain(player).Pos.X;
          
          self.PlayerBrainPos[player] = self:GetPlayerBrain(player).Pos.X;
          self.PlayerBrainPos[player] = self:GetPlayerBrain(player).Pos.X;
          
					--Add objective points
					self:AddObjectivePoint("Protect!", self:GetPlayerBrain(player).AboveHUDPos, team, GameActivity.ARROWDOWN);
--					for player2 = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
--						if player2 ~= player and self:PlayerActive(player2) and self:PlayerHuman(player2) and MovableMan:IsActor(self:GetPlayerBrain(player2)) then
--							local team2 = self:GetTeamOfPlayer(player2);
--							self:AddObjectivePoint("Destroy!", self:GetPlayerBrain(player2).AboveHUDPos, team, GameActivity.ARROWDOWN);
--						end
--					end
				end
			end
		end
    --Find brain average point
    local i = braincount
    if braincount > 0 then
      while i > 0 do
        if brainPositionX[i]-brainPositionX[1] > SceneMan.SceneWidth/2 then
          brainPositionX[i] = brainPositionX[i] - SceneMan.SceneWidth;
        else
          if brainPositionX[i]+brainPositionX[1] < SceneMan.SceneWidth/2 then
            brainPositionX[i] = brainPositionX[i] + SceneMan.SceneWidth;
          end
        end
        brainPositionX2 = brainPositionX2+brainPositionX[i];
        i = i - 1
      end
      brainPositionX2 = brainPositionX2/(braincount);
    end
		--Spawn the AI.
    if brainPositionX2 > SceneMan.SceneWidth/2 then
      brainPositionX2 = brainPositionX2 - SceneMan.SceneWidth/2;
    else
      brainPositionX2 = brainPositionX2 + SceneMan.SceneWidth/2;
    end
    EnemySpawnX1 = brainPositionX2;
    EnemySpawnX2 = brainPositionX2;
        
		if self.CPUTeam == nil then
			self.CPUTeam = Activity.NOTEAM;
			for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
				if self:PlayerActive(player) and not(self:PlayerHuman(player)) then
					local team = self:GetTeamOfPlayer(player);
					self.CPUTeam = team;
				end
			end
		end

		self.currentenemies = 0;
		local workingX = 0
		for actor in MovableMan.Actors do
			if (actor.ClassName == "ACrab" or actor.ClassName == "AHuman") and actor.Team == self.CPUTeam then
				self.currentenemies = self.currentenemies + 1;
				workingX = actor.Pos.X;
				if workingX > brainPositionX2 + SceneMan.SceneWidth/2 then
          workingX = workingX-SceneMan.SceneWidth;
        else
          if workingX < brainPositionX2 - SceneMan.SceneWidth/2 then
            workingX = workingX+SceneMan.SceneWidth;
          end
        end
        if workingX > EnemySpawnX1 then
          EnemySpawnX1 = workingX
        end
        if workingX < EnemySpawnX2 then
          EnemySpawnX2 = workingX
        end
			end
		end
    local AIcontrol = (EnemySpawnX1 - EnemySpawnX2)/SceneMan.SceneWidth
    if self.ESpawnTimer:IsPastSimMS(self.wavewaittime+(self.currentenemies * (self.wavewaittime - 5000) * 0.1)) and self.CPUTeam ~= Activity.NOTEAM and MovableMan:GetMOIDCount() <= 210 and self.StopSending < 0 then
      local actor = {};
      for x = 0, math.ceil(math.random(self.maxDeliveryLoad-self.minDeliveryLoad)) + self.minDeliveryLoad do
        local y = math.random();
        if y > self.chanceOfCrab or self.TechElapsed < 120 then
          local Tech = math.random(0, self.TechElapsed)
          if Tech < 100 - self.TechElapsed * 0.25 then
            actor[x] = CreateAHuman(self.SimpleBodyList[math.random(#self.SimpleBodyList)]);
          else
            if Tech < 240 then
              actor[x] = CreateAHuman(self.BodyList[math.random(#self.BodyList)]);
            else
              actor[x] = CreateAHuman(self.AdvancedBodyList[math.random(#self.AdvancedBodyList)]);
            end
          end
          actor[x].Team = self.CPUTeam;
          actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
          Tech = math.random(0, self.TechElapsed)
          if Tech < 75 - self.TechElapsed * 0.15 then
            actor[x]:AddInventoryItem(CreateHDFirearm(self.SecondaryWeaponList[math.random(#self.SecondaryWeaponList)]));
          else
            if Tech < 180 then
              if math.random() < AIcontrol then
                actor[x]:AddInventoryItem(CreateHDFirearm(self.PrimaryWeaponList[math.random(#self.PrimaryWeaponList)]));
              else
                actor[x]:AddInventoryItem(CreateHDFirearm(self.ShortRangePrimaryWeaponList[math.random(#self.ShortRangePrimaryWeaponList)]));
              end
              actor[x]:AddInventoryItem(CreateHDFirearm(self.SecondaryWeaponList[math.random(#self.SecondaryWeaponList)]));
            else
              if math.random() < AIcontrol then
                actor[x]:AddInventoryItem(CreateHDFirearm(self.AdvancedPrimaryWeaponList[math.random(#self.AdvancedPrimaryWeaponList)]));
              else
                actor[x]:AddInventoryItem(CreateHDFirearm(self.AdvancedShortRangePrimaryWeaponList[math.random(#self.AdvancedShortRangePrimaryWeaponList)]));
              end
              actor[x]:AddInventoryItem(CreateHDFirearm(self.SecondaryWeaponList[math.random(#self.SecondaryWeaponList)]));
              if math.random(0, self.TechElapsed) > 150 then
                actor[x]:AddInventoryItem(CreateHeldDevice(self.ShieldList[math.random(#self.ShieldList)]));
              end
            end
          end
          Tech = math.random(0, self.TechElapsed)
          if Tech > 100 then
            actor[x]:AddInventoryItem(CreateTDExplosive(self.BombList[math.random(#self.BombList)]));
          end
          actor[x]:AddInventoryItem(CreateHDFirearm(self.DiggerList[math.random(#self.DiggerList)]));
        else
          actor[x] = CreateACrab(self.CrabList[math.random(#self.CrabList)]);
          actor[x].Team = self.CPUTeam;
          actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
        end
      end
      local ship = nil;
      if math.random() < (AIcontrol * 4) - 3 then
        ship = CreateACRocket(self.PodList[math.random(#self.PodList)]);
      else
        if math.random() < (AIcontrol * 2) - 1 then
          ship = CreateACRocket(self.RocketList[math.random(#self.RocketList)]);
        else
          ship = CreateACDropShip(self.DropShipList[math.random(#self.DropShipList)]);
        end
      end

      for n = 0, #actor do
        ship:AddInventoryItem(actor[n]);
      end
      ship.Team = self.CPUTeam;
      if math.random() < 0.5 then
        if EnemySpawnX1 - brainPositionX2 < SceneMan.SceneWidth*0.25 then
          ship.Pos = Vector(EnemySpawnX1 + math.random(-200, 600),0);
        else
          ship.Pos = Vector(EnemySpawnX1 + math.random(-500, -100) + math.min(600 , self.TechElapsed),0);
        end
      else
        if brainPositionX2 - EnemySpawnX2 < SceneMan.SceneWidth*0.25 then
          ship.Pos = Vector(EnemySpawnX2 + math.random(-600, 200),0);
        else
          ship.Pos = Vector(EnemySpawnX2 + math.random(100, 500) - math.min(600 , self.TechElapsed),0);
        end
      end
      MovableMan:AddActor(ship);

      self.ESpawnTimer:Reset();
    end

		--Win/Lose Conditions
		if self.CPUTeam == Activity.NOTEAM then
			if self.playertally == 1 then
				for i = 1, #self.playerlist do
					if self.playerlist[i] == true then
						self.WinnerTeam = i - 1;
						ActivityMan:EndActivity();
					end
				end
			end
		else
			if self.playertally == 0 then
				self.WinnerTeam = self.CPUTeam;
				ActivityMan:EndActivity();
        AudioMan:ClearMusicQueue();
        AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/udiedfinal.ogg", -1, -1);
			end
		end
      
    
    --Special Wave Logic
    if self.timeElapsed >= self.Specialtime then
      local once = false
      if self.SpecialStage == 0 and once == false then
        local enemyAttackAmount = (3 + math.floor(self.timeElapsed * 0.005))*(self.Diff^0.5)
        self.Specialtime = self.Specialtime + 1
        self.SpecialStage = 1
        self.SpecialStageRepeat = enemyAttackAmount
        once = true
      end
      
      --Browncoat
      
      if self.SpecialStage == 1 and once == false then
        local actor = nil;
        actor = CreateAHuman(self.AdvancedBodyList[math.random(#self.AdvancedBodyList)]);
        actor.Team = self.CPUTeam;
        actor.AIMode = Actor.AIMODE_BRAINHUNT;
        actor:AddInventoryItem(CreateHDFirearm(self.AdvancedPrimaryWeaponList[math.random(#self.AdvancedPrimaryWeaponList)]));
        actor:AddInventoryItem(CreateHDFirearm(self.SecondaryWeaponList[math.random(#self.SecondaryWeaponList)]));
        
        local ship = nil;
        ship = CreateACRocket(self.PodList[math.random(#self.PodList)]);
        ship:AddInventoryItem(actor);
        ship.Team = self.CPUTeam;
        ship.Pos = Vector(EnemySpawnX2 + math.random(-400, -200),0);
        MovableMan:AddActor(ship);
        if self.SpecialStageRepeat > 1 and MovableMan:GetMOIDCount() <= 210 then
          self.Specialtime = self.Specialtime + 1
          self.SpecialStage = 2
          self.SpecialStageRepeat = self.SpecialStageRepeat - 1
        else
          self.Specialtime = self.Specialtime + 15 / (self.Diff^0.5)
          self.SpecialStage = 3
          self.StopSending = 10
        end
        once = true
      end
      if self.SpecialStage == 2 and once == false then
        local actor = nil;
        actor = CreateAHuman(self.AdvancedBodyList[math.random(#self.AdvancedBodyList)]);
        actor.Team = self.CPUTeam;
        actor.AIMode = Actor.AIMODE_BRAINHUNT;
        actor:AddInventoryItem(CreateHDFirearm(self.AdvancedPrimaryWeaponList[math.random(#self.AdvancedPrimaryWeaponList)]));
        actor:AddInventoryItem(CreateHDFirearm(self.SecondaryWeaponList[math.random(#self.SecondaryWeaponList)]));
        
        local ship = nil;
        ship = CreateACRocket(self.PodList[math.random(#self.PodList)]);
        ship:AddInventoryItem(actor);
        ship.Team = self.CPUTeam;
        ship.Pos = Vector(EnemySpawnX1 + math.random(200, 400),0);
        MovableMan:AddActor(ship);
        if self.SpecialStageRepeat > 1 and MovableMan:GetMOIDCount() <= 210 then
          self.Specialtime = self.Specialtime + 1
          self.SpecialStage = 1
          self.SpecialStageRepeat = self.SpecialStageRepeat - 1
        else
          self.Specialtime = self.Specialtime + 15 / (self.Diff^0.5)
          self.SpecialStage = 3
          self.StopSending = 10
        end
        once = true
      end
      
      
      if self.SpecialStage == 3 and once == false then
        self.TechElapsed = self.TechElapsed / 10
        self.Specialtime = self.Specialtime + 90 / self.Diff^0.5
        self.SpecialStage = 4
        once = true
      end
      if self.SpecialStage == 4 and once == false then
        local enemyAttackAmount = (3 + math.floor(self.timeElapsed * 0.005))*(self.Diff^0.5)
        self.Specialtime = self.Specialtime + 1
        self.SpecialStage = 5
        self.SpecialStageRepeat = enemyAttackAmount
        once = true
      end
      
      --Dreadnaught
      
      if self.SpecialStage == 5 then
        local actor = nil;
        actor = CreateACrab(self.CrabList[math.random(#self.CrabList)]);
        actor.Team = self.CPUTeam;
        actor.AIMode = Actor.AIMODE_BRAINHUNT;
        
        local ship = nil;
        ship = CreateACRocket(self.PodList[math.random(#self.PodList)]);
        ship:AddInventoryItem(actor);
        ship.Team = self.CPUTeam;
        ship.Pos = Vector(EnemySpawnX1 + math.random(0, 200),0);
        MovableMan:AddActor(ship);
        if self.SpecialStageRepeat > 1 and MovableMan:GetMOIDCount() <= 210 then
          self.Specialtime = self.Specialtime + 1
          self.SpecialStage = 6
          self.SpecialStageRepeat = self.SpecialStageRepeat - 1
        else
          self.Specialtime = self.Specialtime + 90 / (self.Diff^0.5)
          self.SpecialStage = 7
          self.StopSending = 10
        end
        once = true
      end
      if self.SpecialStage == 6 and once == false then
        local actor = nil;
        actor = CreateACrab(self.CrabList[math.random(#self.CrabList)]);
        actor.Team = self.CPUTeam;
        actor.AIMode = Actor.AIMODE_BRAINHUNT;
        
        local ship = nil;
        ship = CreateACRocket(self.PodList[math.random(#self.PodList)]);
        ship:AddInventoryItem(actor);
        ship.Team = self.CPUTeam;
        ship.Pos = Vector(EnemySpawnX2 + math.random(-200, 0),0);
        MovableMan:AddActor(ship);
        if self.SpecialStageRepeat > 1 and MovableMan:GetMOIDCount() <= 210 then
          self.Specialtime = self.Specialtime + 1
          self.SpecialStage = 5
          self.SpecialStageRepeat = self.SpecialStageRepeat - 1
        else
          self.Specialtime = self.Specialtime + 90 / (self.Diff^0.5)
          self.SpecialStage = 7
          self.StopSending = 10
        end
        once = true
      end
      if self.SpecialStage == 7 and once == false then
        local enemyAttackAmount = 1 + math.floor(self.timeElapsed * 0.01) + 1 * self.Diff^0.5
        self.Specialtime = self.Specialtime + 1
        self.SpecialStage = 8
        self.SpecialStageRepeat = enemyAttackAmount
        once = true
        self.StopSending = 5;
      end
      
      --Assault Coalition
      
      if self.SpecialStage == 8 and once == false then
        local actor = nil;
        actor = CreateAHuman("Coalition Assault");
        actor.Team = self.CPUTeam;
        actor.AIMode = Actor.AIMODE_BRAINHUNT;
        actor.Pos = Vector(brainPositionX2 + math.random(-800, 800),0);
        MovableMan:AddActor(actor);
        actor:AddInventoryItem(CreateHDFirearm("Auto Shotgun"));
        actor:AddInventoryItem(CreateHDFirearm("Auto Pistol"));
        
        if self.SpecialStageRepeat > 1 and MovableMan:GetMOIDCount() <= 210 then
          self.Specialtime = self.Specialtime + 1
          self.SpecialStage = 9
          self.SpecialStageRepeat = self.SpecialStageRepeat - 1
        else
          self.Specialtime = self.Specialtime + 5 / (self.Diff^0.5)
          self.SpecialStage = 10
          self.StopSending = 10
        end
        once = true
      end
      if self.SpecialStage == 9 and once == false then
        local actor = nil;
        actor = CreateAHuman("Coalition Assault");
        actor.Team = self.CPUTeam;
        actor.AIMode = Actor.AIMODE_BRAINHUNT;
        actor.Pos = Vector(brainPositionX2 + math.random(-800, 800),0);
        MovableMan:AddActor(actor);
        actor:AddInventoryItem(CreateHDFirearm("Auto Shotgun"));
        actor:AddInventoryItem(CreateHDFirearm("Auto Pistol"));

        if self.SpecialStageRepeat > 1 and MovableMan:GetMOIDCount() <= 210 then
          self.Specialtime = self.Specialtime + 1
          self.SpecialStage = 8
          self.SpecialStageRepeat = self.SpecialStageRepeat - 1
        else
          self.Specialtime = self.Specialtime + 5 / (self.Diff^0.5)
          self.SpecialStage = 10
          self.StopSending = 10
        end
        once = true
      end
      
      
      if self.SpecialStage == 10 and once == false then
        self.TechElapsed = self.TechElapsed / 10
        self.Specialtime = self.Specialtime + 90 / (self.Diff^0.5)
        self.SpecialStage = 0
        once = true
      end
    end
	else
		self.StartTimer:Reset();
	end

end